GEGELATI

Loading...
Searching...
No Matches
Public Member Functions | Protected Attributes | List of all members
Learn::ClassificationLearningEnvironment Class Referenceabstract

Specialization of the LearningEnvironment class for classification purposes. More...

`#include <classificationLearningEnvironment.h>`

Inheritance diagram for Learn::ClassificationLearningEnvironment:

## Public Member Functions
| ClassificationLearningEnvironment (uint64_t nbClass)
const std::vector< std::vector< uint64_t > > & | getClassificationTable () const
| Get a const ref to the classification table of the learning environment.
virtual void | doAction (double actionID) override=0
| Default implementation for the doAction method.
virtual double | getScore () const override
| Default scoring for classificationLearningEnvironment.
virtual void | reset (size_t seed=0, LearningMode mode=LearningMode::TRAINING, uint16_t iterationNumber=0, uint64_t generationNumber=0) override=0
| Default implementation of the reset.
Public Member Functions inherited from Learn::LearningEnvironment
| LearningEnvironment ()=delete
| Delete the default constructor of a LearningEnvironment.
virtual | ~LearningEnvironment ()=default
| Default virtual destructor.
| LearningEnvironment (uint64_t nbAct, bool isDiscreteEnv=true, const std::vector< uint64_t > &initAct=std::vector< uint64_t >())
| Constructor for LearningEnviroment.
virtual LearningEnvironment * | clone () const
| Get a copy of the LearningEnvironment.
virtual bool | isCopyable () const
| Can the LearningEnvironment be copy constructed to evaluate several LearningAgent in parallel.
virtual bool | isUsingUtility () const
| Is the LearningEnvrionment using a utility in addition to the reward. Information needed for the logs.
uint64_t | getNbActions () const
| Get the number of actions available for this LearningEnvironment.
const std::vector< uint64_t > & | getInitActions () const
| Get the vector of initial actions available for this LearningEnvironment.
const bool | isDiscrete () const
| Get the information of the nature of the environment action type.
virtual void | doActions (std::vector< double > vectActionID)
| Execute actions on the LearningEnvironment.
virtual std::vector< std::reference_wrapper< const Data::DataHandler > > | getDataSources ()=0
| Get the data sources for this LearningEnvironment.
virtual double | getUtility () const
| Returns the current utility of the Environment.
virtual bool | isTerminal () const =0
| Method for checking if the LearningEnvironment has reached a terminal state.

## Protected Attributes
std::vector< std::vector< uint64_t > > | classificationTable
| 2D array storing for each class the guesses that were made by the LearningAgent.
uint64_t | currentClass
| Class of the current data.
Protected Attributes inherited from Learn::LearningEnvironment
const uint64_t | nbActions
const bool | isDiscreteEnvironment
const std::vector< uint64_t > | initActions

## Additional Inherited Members
Protected Member Functions inherited from Learn::LearningEnvironment
| LearningEnvironment (const LearningEnvironment &other)=default
| Make the default copy constructor protected.

## Detailed Description

Specialization of the LearningEnvironment class for classification purposes.

## Constructor & Destructor Documentation

## ◆ ClassificationLearningEnvironment()

Learn::ClassificationLearningEnvironment::ClassificationLearningEnvironment | ( | uint64_t | nbClass | ) |
| inline

Main constructor of the ClassificationLearningEnvironment.

Parameters

  [in] | nbClass | number of classes of the classificationLearningEnvironment, and thus number of action of the underlying LearningEnvironment.

## Member Function Documentation

## ◆ doAction()

void Learn::ClassificationLearningEnvironment::doAction | ( | double | actionID | ) |
| override pure virtual

Default implementation for the doAction method.

This implementation only increments the classificationTable based on the currentClass attribute. Refresh of the data should be implemented by the child class, hence the pure virtual method.

Copyright or © or Copr. IETR/INSA - Rennes (2019 - 2025) :

Karol Desnos kdesn.nosp@m.os@i.nosp@m.nsa-r.nosp@m.enne.nosp@m.s.fr (2019 - 2020) Quentin Vacher qvach.nosp@m.er@i.nosp@m.nsa-r.nosp@m.enne.nosp@m.s.fr (2024 - 2025)

GEGELATI is an open-source reinforcement learning framework for training artificial intelligence based on Tangled Program Graphs (TPGs).

This software is governed by the CeCILL-C license under French law and abiding by the rules of distribution of free software. You can use, modify and/ or redistribute the software under the terms of the CeCILL-C license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".

As a counterpart to the access to the source code and rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty and the software's author, the holder of the economic rights, and the successive licensors have only limited liability.

In this respect, the user's attention is drawn to the risks associated with loading, using, modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean that it is complicated to manipulate, and that also therefore means that it is reserved for developers and experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or data to be ensured and, more generally, to use and operate it in the same conditions as regards security.

The fact that you are presently reading this means that you have had knowledge of the CeCILL-C license and that you accept its terms.

Reimplemented from Learn::LearningEnvironment.

## ◆ getScore()

double Learn::ClassificationLearningEnvironment::getScore | ( |  | ) | const
| override virtual

Default scoring for classificationLearningEnvironment.

The default scoring for the classificationLearningEnvironment is computed based on the classificationTable attribute.

The score represents the percentage of correct classification.

Implements Learn::LearningEnvironment.

## ◆ reset()

void Learn::ClassificationLearningEnvironment::reset | ( | size_t | seed = 0,
|  | LearningMode | mode = LearningMode::TRAINING,
|  | uint16_t | iterationNumber = 0,
|  | uint64_t | generationNumber = 0 )
| override pure virtual

Default implementation of the reset.

Resets to zero the classificationTable.

Implements Learn::LearningEnvironment.

## Member Data Documentation

## ◆ classificationTable

std::vector<std::vector<uint64_t> > Learn::ClassificationLearningEnvironment::classificationTable
| protected

2D array storing for each class the guesses that were made by the LearningAgent.

For example classificationTable.at(x).at(y) represents the number of times a LearningAgent guessed class y, for a data from class x since the last reset.

## ◆ currentClass

uint64_t Learn::ClassificationLearningEnvironment::currentClass
| protected

Class of the current data.

This attribute should be updated alongside the data made avalaible to the LearningAgent.

The documentation for this class was generated from the following files:

- D:/a/gegelati/gegelati/gegelatilib/include/learn/classificationLearningEnvironment.h
- D:/a/gegelati/gegelati/gegelatilib/src/learn/classificationLearningEnvironment.cpp